#include "precompile.h"

#include "android.h"
#include "metamgr.h"
#include "android.ai.h"
#include "room.h"
#include "app.h"

Android::Android():Human()
{
    entity_type = ET_Player;
    entity_subtype = EST_Android;
    ai = new AndroidAI;
    ai->owner = this;
    ++App::Instance()->perf.entity_num[ET_Android];
}

Android::~Android()
{
    delete ai;
    ai = nullptr;
    --App::Instance()->perf.entity_num[ET_Android];
}

void Android::Initialize()
{
    Human::Initialize();
    health = meta->i->health();
    skin.skin_id = 14001;
    skin.skin_lv = 1;
}

void Android::Update(int delta_time)
{
    if (a8::HasBitFlag(status, HS_Fly)) {
        pos = room->plane.curr_pos;
        room->grid_service.MoveHuman(this);
    }
    if (action_type != AT_None) {
        UpdateAction();
    }
    ai->Update(delta_time);
}
