#pragma once

namespace cs
{
    class CMJoin;
}

namespace ss
{
    class SS_WSP_SocketDisconnect;
}

class Player;
class PlayerMgr : public a8::Singleton<PlayerMgr>
{
 public:
    enum { HID = HID_PlayerMgr };

 private:
    PlayerMgr() {};
    friend class a8::Singleton<PlayerMgr>;

 public:
    void Init();
    void UnInit();

    void _SS_WSP_SocketDisconnect(f8::MsgHdr& hdr, const ss::SS_WSP_SocketDisconnect& msg);

    int OnlineNum();
    Player* GetPlayerBySocket(int socket);
    Player* CreatePlayerByCMJoin(int socket, const cs::CMJoin& msg);
    void OnClientDisconnect(a8::XParams& param);
    void RemovePlayerBySocket(int socket_handle);

 private:
    std::map<int, Player*> socket_hash_;
};
