#pragma once

#include "ss_proto.pb.h"

struct GSNode
{
    std::string key;
    unsigned short node_idx = 0;
    int node_id = 0;
    int instance_id = 0;
    int room_num = 0;
    int online_num = 0;
    std::string ip;
    int port = 0;
    bool servicing = false;
};

class GSMgr : public a8::Singleton<GSMgr>
{
 public:
    enum { HID = HID_GSMgr };

 private:
    GSMgr() {};
    friend class a8::Singleton<GSMgr>;

 public:

    void Init();
    void UnInit();

    void _SS_WSP_RequestTargetServer(f8::MsgHdr& hdr, const ss::SS_WSP_RequestTargetServer& msg);

    void ___GSReport(f8::JsonHttpRequest* request);
    void ___GSList(f8::JsonHttpRequest* request);

 private:
    GSNode* GetNodeByTeamId(const std::string& team_id);
    GSNode* AllocNode();
    void RearrangeNode();

 private:

    std::map<std::string, GSNode*> team_hash_;
    std::map<std::string, GSNode> node_key_hash_;
    std::vector<GSNode*> node_sorted_list_;
};
