#include "precompile.h"

#include "jsondatamgr.h"
#include "app.h"

#include "framework/cpp/utils.h"

void JsonDataMgr::Init()
{
    std::string masterserver_cluster_json_file;
    if (!f8::IsOnlineEnv()) {
        if (App::Instance()->flags.find(2) != App::Instance()->flags.end()) {
            masterserver_cluster_json_file = a8::Format("/root/pub/%d/%d/conf_test/game%d/masterserver/node%d/"
                                                      "game%d.masterserver.cluster.json",
                                                      {
                                                       GAME_ID,
                                                       App::Instance()->instance_id,
                                                       GAME_ID,
                                                       App::Instance()->node_id,
                                                       GAME_ID
                                                      });
        } else {
            masterserver_cluster_json_file = a8::Format("/var/data/conf_test/game%d/masterserver/node%d/"
                                                      "game%d.masterserver.cluster.json",
                                                      {
                                                       GAME_ID,
                                                       App::Instance()->node_id,
                                                       GAME_ID
                                                      });
        }
    } else {
        masterserver_cluster_json_file = a8::Format("../config/node%d/game%d.masterserver.cluster.json",
                                                    {
                                                     App::Instance()->node_id,
                                                     GAME_ID
                                                    });
    }
    masterserver_cluster_json_.ReadFromFile(masterserver_cluster_json_file);
}

void JsonDataMgr::UnInit()
{
}

std::shared_ptr<a8::XObject> JsonDataMgr::GetConf()
{
    if (App::Instance()->instance_id < 1 || App::Instance()->instance_id > masterserver_cluster_json_.Size()) {
        abort();
    }
    return masterserver_cluster_json_[App::Instance()->instance_id - 1];
}
